Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 8)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 9)
@@ -25,5 +25,5 @@
 import geniusweb.profile.PartialOrdering;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.UtilitySpace;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
@@ -57,5 +57,6 @@
 			if (info instanceof Settings) {
 				Settings settings = (Settings) info;
-				this.profileint = ProfileConnectionFactory.create(settings.getProfile().getURI(), getReporter());
+				this.profileint = ProfileConnectionFactory
+						.create(settings.getProfile().getURI(), getReporter());
 				this.me = settings.getID();
 				this.progress = settings.getProgress();
@@ -74,5 +75,5 @@
 			}
 		} catch (Exception e) {
-			getReporter().log(Level.SEVERE, "Failed to handle info", e);
+			throw new RuntimeException("Failed to handle info", e);
 		}
 	}
@@ -81,7 +82,9 @@
 	public Capabilities getCapabilities() {
 		try {
-			return new Capabilities(new HashSet<>(Arrays.asList(new ProtocolRef(new URI("SAOP")))));
+			return new Capabilities(new HashSet<>(
+					Arrays.asList(new ProtocolRef(new URI("SAOP")))));
 		} catch (URISyntaxException e) {
-			getReporter().log(Level.SEVERE, "Failed to create capabilities URI", e);
+			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",
+					e);
 			return null;
 		}
@@ -99,5 +102,6 @@
 		} else {
 			// for demo. Obviously full bids have higher util in general
-			AllPartialBidsList bidspace = new AllPartialBidsList(profileint.getProfile().getDomain());
+			AllPartialBidsList bidspace = new AllPartialBidsList(
+					profileint.getProfile().getDomain());
 			Bid bid = null;
 			for (int attempt = 0; attempt < 20 && !isGood(bid); attempt++) {
@@ -115,11 +119,13 @@
 			return false;
 		Profile profile = profileint.getProfile();
-		if (profile instanceof LinearAdditiveUtilitySpace) {
-			return ((LinearAdditiveUtilitySpace) profile).getUtility(bid).doubleValue() > 0.6;
+		if (profile instanceof UtilitySpace) {
+			return ((UtilitySpace) profile).getUtility(bid).doubleValue() > 0.6;
 		}
 		if (profile instanceof PartialOrdering) {
-			return ((PartialOrdering) profile).isPreferredOrEqual(bid, profile.getReservationBid());
+			return ((PartialOrdering) profile).isPreferredOrEqual(bid,
+					profile.getReservationBid());
 		}
-		throw new IllegalArgumentException("Can not handle profile type " + profile.getClass());
+		throw new IllegalArgumentException(
+				"Can not handle profile type " + profile.getClass());
 	}
 
Index: /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java
===================================================================
--- /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 8)
+++ /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 9)
@@ -33,5 +33,5 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
@@ -107,5 +107,5 @@
 	public void testInformSettings() {
 		party.connect(connection);
-		connection.notifyChange(settings);
+		connection.notifyListeners(settings);
 		assertEquals(0, connection.getActions().size());
 	}
@@ -199,5 +199,5 @@
  */
 class TestConnection extends DefaultListenable<Inform>
-		implements Connection<Inform, Action> {
+		implements ConnectionEnd<Inform, Action> {
 	private List<Action> actions = new LinkedList<>();
 
Index: /exampleparties/randompartypy/src/main/resources/RandomParty.py
===================================================================
--- /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 8)
+++ /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 9)
@@ -24,5 +24,5 @@
 import geniusweb.profile.Profile as Profile
 import geniusweb.profile.PartialOrdering as PartialOrdering
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace as LinearAdditiveUtilitySpace
+import geniusweb.profile.utilityspace.UtilitySpace as UtilitySpace
 import geniusweb.references.ProfileRef as ProfileRef
 import geniusweb.references.ProtocolRef as ProtocolRef
@@ -97,5 +97,5 @@
 			return false
 		profile = self.profile.getProfile()
-		if isinstance(profile, LinearAdditiveUtilitySpace):
+		if isinstance(profile, UtilitySpace):
 			return profile.getUtility(bid).doubleValue() > 0.6;
 		if isinstance(profile, PartialOrdering):
Index: /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java
===================================================================
--- /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 8)
+++ /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 9)
@@ -31,5 +31,5 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
@@ -111,5 +111,5 @@
 	public void testInformSettings() {
 		party.connect(connection);
-		connection.notifyChange(settings);
+		connection.notifyListeners(settings);
 		assertEquals(0, connection.getActions().size());
 	}
@@ -190,5 +190,5 @@
  */
 class TestConnection extends DefaultListenable<Inform>
-		implements Connection<Inform, Action> {
+		implements ConnectionEnd<Inform, Action> {
 	private List<Action> actions = new LinkedList<>();
 
Index: /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java
===================================================================
--- /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 8)
+++ /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 9)
@@ -33,5 +33,5 @@
 import geniusweb.actions.PartyId;
 import geniusweb.bidspace.AllBidsList;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.issuevalue.Bid;
 import geniusweb.party.Capabilities;
@@ -118,5 +118,5 @@
 	public void testInformSettings() {
 		party.connect(connection);
-		connection.notifyChange(settings);
+		connection.notifyListeners(settings);
 		assertEquals(0, connection.getActions().size());
 	}
@@ -223,5 +223,5 @@
  */
 class TestConnection extends DefaultListenable<Inform>
-		implements Connection<Inform, Action> {
+		implements ConnectionEnd<Inform, Action> {
 	private List<Action> actions = new LinkedList<>();
 
Index: /issuevalue/src/main/java/geniusweb/issuevalue/Bid.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/Bid.java	(revision 8)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/Bid.java	(revision 9)
@@ -98,4 +98,12 @@
 	}
 
+	/**
+	 * 
+	 * @return (unmodifyable) map with all issues and values in the bid.
+	 */
+	public Map<String, Value> getIssueValues() {
+		return Collections.unmodifiableMap(issuevalues);
+	}
+
 	@Override
 	public String toString() {
Index: /party/src/main/java/geniusweb/party/DefaultParty.java
===================================================================
--- /party/src/main/java/geniusweb/party/DefaultParty.java	(revision 8)
+++ /party/src/main/java/geniusweb/party/DefaultParty.java	(revision 9)
@@ -2,5 +2,5 @@
 
 import geniusweb.actions.Action;
-import geniusweb.connection.Connection;
+import geniusweb.connection.ConnectionEnd;
 import geniusweb.party.inform.Inform;
 import tudelft.utilities.listener.Listener;
@@ -13,5 +13,5 @@
  */
 public abstract class DefaultParty implements Party, Listener<Inform> {
-	private Connection<Inform, Action> connection = null;
+	private ConnectionEnd<Inform, Action> connection = null;
 	protected Reporter reporter;
 
@@ -25,5 +25,5 @@
 
 	@Override
-	public void connect(Connection<Inform, Action> connection) {
+	public void connect(ConnectionEnd<Inform, Action> connection) {
 		this.connection = connection;
 		connection.addListener(this);
@@ -47,5 +47,5 @@
 	 *         connected.
 	 */
-	public Connection<Inform, Action> getConnection() {
+	public ConnectionEnd<Inform, Action> getConnection() {
 		return connection;
 	}
Index: /profile/src/main/java/geniusweb/profile/Profile.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/Profile.java	(revision 8)
+++ /profile/src/main/java/geniusweb/profile/Profile.java	(revision 9)
@@ -7,4 +7,5 @@
 import geniusweb.issuevalue.Domain;
 import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.SumOfGroupsUtilitySpace;
 
 /**
@@ -17,5 +18,6 @@
 @JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
 @JsonSubTypes({ @JsonSubTypes.Type(value = LinearAdditiveUtilitySpace.class),
-		@JsonSubTypes.Type(value = DefaultPartialOrdering.class) })
+		@JsonSubTypes.Type(value = DefaultPartialOrdering.class),
+		@JsonSubTypes.Type(value = SumOfGroupsUtilitySpace.class) })
 public interface Profile {
 
@@ -33,8 +35,9 @@
 	/**
 	 * 
-	 * @return a (hypothetical) bid that is the best alternative to a non-agreement.
-	 *         Only bids that are {@link #isPreferredOrEqual(Bid, Bid)} should be
-	 *         accepted. If a negotiation does not reach an agreement, the party can
-	 *         get this offer somewhere else. This replaces the older notion of a
+	 * @return a (hypothetical) bid that is the best alternative to a
+	 *         non-agreement. Only bids that are
+	 *         {@link #isPreferredOrEqual(Bid, Bid)} should be accepted. If a
+	 *         negotiation does not reach an agreement, the party can get this
+	 *         offer somewhere else. This replaces the older notion of a
 	 *         "reservation value" and is more general. If null, there is no
 	 *         reservation bid and any agreement is better than no agreement.
Index: /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 8)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 9)
@@ -8,4 +8,5 @@
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
 import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonTypeName;
 
 import geniusweb.issuevalue.DiscreteValue;
@@ -13,6 +14,4 @@
 import geniusweb.issuevalue.Value;
 import geniusweb.issuevalue.ValueSet;
-
-import com.fasterxml.jackson.annotation.JsonTypeName;
 
 /**
@@ -37,19 +36,23 @@
 	 * create new object based on the given mapping from values to utilities.
 	 * 
-	 * @param valueUtils map with key {@link DiscreteValue}s and value a Double in
-	 *                   the range [0,1].
+	 * @param valueUtils map with key {@link DiscreteValue}s and value a Double
+	 *                   in the range [0,1].
 	 * @throws NullPointerException     if one of the args is null
 	 * @throws IllegalArgumentException if values are not in range [0,1].
 	 */
-	public DiscreteValueSetUtilities(Map<DiscreteValue, BigDecimal> valueUtils) {
+	public DiscreteValueSetUtilities(
+			Map<DiscreteValue, BigDecimal> valueUtils) {
 		if (valueUtils == null) {
 			throw new NullPointerException("valueUtils==null");
 		}
 		if (valueUtils.keySet().contains(null)) {
-			throw new NullPointerException("one of the keys in valueUtils is null");
+			throw new NullPointerException(
+					"one of the keys in valueUtils is null");
 		}
 		if (valueUtils.values().stream()
-				.anyMatch(v -> v == null || v.compareTo(BigDecimal.ZERO) < 0 || v.compareTo(BigDecimal.ONE) > 0)) {
-			throw new IllegalArgumentException("Weights in valueUtils must all be in [0,1]");
+				.anyMatch(v -> v == null || v.compareTo(BigDecimal.ZERO) < 0
+						|| v.compareTo(BigDecimal.ONE) > 0)) {
+			throw new IllegalArgumentException(
+					"Weights in valueUtils must all be in [0,1]");
 		}
 		this.valueUtilities.putAll(valueUtils);
@@ -68,9 +71,12 @@
 	public String isFitting(ValueSet valueset) {
 		if (!(valueset instanceof DiscreteValueSet)) {
-			return "The utilities are for a discrete valueset but the given values are " + valueset;
+			return "The utilities are for a discrete valueset but the given values are "
+					+ valueset;
 		}
 		DiscreteValueSet discvalueset = (DiscreteValueSet) valueset;
-		if (!valueUtilities.keySet().equals(new HashSet<>(discvalueset.getValues())))
-			return "The values in the set " + valueset + " do not match the values mapped to utilities "
+		if (!valueUtilities.keySet()
+				.equals(new HashSet<>(discvalueset.getValues())))
+			return "The values in the set " + valueset
+					+ " do not match the values mapped to utilities "
 					+ valueUtilities.keySet();
 		return null;
@@ -79,5 +85,5 @@
 	@Override
 	public String toString() {
-		return "ValueSetUtilities" + valueUtilities;
+		return "DiscreteValueSetUtilities" + valueUtilities;
 	}
 
@@ -86,5 +92,6 @@
 		final int prime = 31;
 		int result = 1;
-		result = prime * result + ((valueUtilities == null) ? 0 : valueUtilities.hashCode());
+		result = prime * result
+				+ ((valueUtilities == null) ? 0 : valueUtilities.hashCode());
 		return result;
 	}
Index: /profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java	(revision 8)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java	(revision 9)
@@ -139,5 +139,5 @@
 	@Override
 	public String toString() {
-		return "NumberValUtility(" + lowValue + "->" + lowUtility + ","
+		return "NumberValueSetUtilities(" + lowValue + "->" + lowUtility + ","
 				+ highValue + "->" + highUtility + ")";
 	}
Index: /profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java	(revision 9)
@@ -0,0 +1,244 @@
+package geniusweb.profile.utilityspace;
+
+import java.math.BigDecimal;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.annotation.JsonTypeName;
+
+import geniusweb.issuevalue.Value;
+import geniusweb.issuevalue.ValueSet;
+
+/**
+ * Contains utilities of a ProductOfValue of a {@link SumOfGroupsUtilitySpace}.
+ * So this is similar to a DiscreteValueSetUtilities but instead of issues this
+ * contains an (ordered) list of issues. This object serializes to something
+ * like <code> 
+ * {"partsutils":
+ * {"issues":["issue1","issue2"],
+ * "utilslist":[{"values":["low","low"],"util":0.3},{"values":["high","high"],"util":0.9}]}}
+ </code> The issues field contains a list of N issues in the domain, The
+ * utilslist contains a list of dictionaries, with "values" containing a list of
+ * N issue values, in the same order as the issues list and with "util"
+ * containng the utility value of that set of values.
+ * <p>
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+@JsonTypeName("partsutils")
+public class PartsUtilities implements ValueSetUtilities {
+	private final List<String> issues;
+	// the real but not-serializable values (because Map can only have String
+	// keys in jackson)
+	private transient final Map<ProductOfValue, BigDecimal> utilities = new HashMap<>();
+	// copy only for serializing
+	private final List<PartUtil> utilslist = new LinkedList<>();
+
+	/**
+	 * 
+	 * @param issues
+	 * @param utils  with keys: list of values and value: utility value for that
+	 *               list of values. All list-of-values missing from the map are
+	 *               assumed to have utility 0. This includes partial bids where
+	 *               list-of-values contain null objects.
+	 */
+	public PartsUtilities(List<String> issues,
+			Map<ProductOfValue, BigDecimal> utils) {
+		if (issues == null || utils == null) {
+			throw new IllegalArgumentException(
+					"issues and utils must be not null");
+		}
+
+		this.issues = issues;
+		this.utilities.putAll(utils);
+
+		checkUtilities();
+		for (ProductOfValue pval : utils.keySet()) {
+			utilslist.add(new PartUtil(pval.getValues(), utils.get(pval)));
+		}
+	}
+
+	@JsonCreator
+	public PartsUtilities(@JsonProperty("issues") List<String> issues,
+			@JsonProperty("utilslist") List<PartUtil> utilslist) {
+		this(issues, list2map(utilslist));
+	}
+
+	/**
+	 * 
+	 * @param pval the {@link ProductOfValue} value
+	 * @return the utility of the value, in the same order as
+	 *         {@link #getIssues()}. Returns 0 if there is no utility set for
+	 *         the given combination of values. Notice, partial bids will
+	 *         usually have utility 0.
+	 * 
+	 */
+	@Override
+	public BigDecimal getUtility(Value pval) {
+		BigDecimal val = utilities.get(pval);
+		if (val == null)
+			return BigDecimal.ZERO;
+		return val;
+	}
+
+	@Override
+	public String isFitting(ValueSet valueset) {
+		return null; // what can we tests here?
+	}
+
+	/**
+	 * @return the issues that are contained here.
+	 */
+	public List<String> getIssues() {
+		return issues;
+	}
+
+	/**
+	 * 
+	 * @return map with all available values and their utilities. The map and
+	 *         its contents should all be immutable.
+	 */
+	public Map<ProductOfValue, BigDecimal> getUtilities() {
+		return Collections.unmodifiableMap(utilities);
+	}
+
+	/**
+	 * 
+	 * @param other another {@link PartsUtilities} map. The issues in the other
+	 *              map must be different from {@link #issues}.
+	 * @return new PartsUtils, with the powermap of all combinations of one
+	 *         element from this and one from the other map, and with the
+	 *         utilities computed as the sum of thisvalue + othervalue.
+	 */
+	public PartsUtilities add(PartsUtilities other) {
+		for (String issue : issues) {
+			if (other.issues.contains(issue)) {
+				throw new IllegalArgumentException(
+						"Issue " + issue + " exists already");
+			}
+		}
+
+		List<String> combinedissues = new LinkedList<String>(issues);
+		combinedissues.addAll(other.issues);
+
+		Map<ProductOfValue, BigDecimal> combinedvalues = new HashMap<>();
+		for (ProductOfValue productOfValue : this.utilities.keySet()) {
+			for (ProductOfValue otherProductOfValue : other.utilities
+					.keySet()) {
+				BigDecimal combinedutil = getUtility(productOfValue)
+						.add(other.getUtility(otherProductOfValue));
+				combinedvalues.put(productOfValue.merge(otherProductOfValue),
+						combinedutil);
+			}
+		}
+		return new PartsUtilities(combinedissues, combinedvalues);
+
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((issues == null) ? 0 : issues.hashCode());
+		result = prime * result
+				+ ((utilities == null) ? 0 : utilities.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		PartsUtilities other = (PartsUtilities) obj;
+		if (issues == null) {
+			if (other.issues != null)
+				return false;
+		} else if (!issues.equals(other.issues))
+			return false;
+		if (utilities == null) {
+			if (other.utilities != null)
+				return false;
+		} else if (!utilities.equals(other.utilities))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "PartsUtilities[" + issues + "," + utilities + "]";
+	}
+
+	private void checkUtilities() {
+		if (utilities.values().stream()
+				.anyMatch(v -> v == null || v.compareTo(BigDecimal.ZERO) < 0
+						|| v.compareTo(BigDecimal.ONE) > 0)) {
+			throw new IllegalArgumentException(
+					"part weights must all be in [0,1]");
+		}
+	}
+
+	private static Map<ProductOfValue, BigDecimal> list2map(
+			List<PartUtil> list) {
+		Map<ProductOfValue, BigDecimal> map = new HashMap<>();
+		for (PartUtil partutil : list) {
+			map.put(new ProductOfValue(partutil.getValues()),
+					partutil.getUtil());
+		}
+		return map;
+	}
+
+	/**
+	 * 
+	 * @return the max utility of all values contained here.
+	 */
+	public BigDecimal getMaxUtility() {
+		BigDecimal maxutil = BigDecimal.ZERO;
+		for (ProductOfValue vakye : utilities.keySet()) {
+			if (utilities.get(vakye).compareTo(maxutil) > 0) {
+				maxutil = utilities.get(vakye);
+			}
+
+		}
+		return maxutil;
+	}
+
+}
+
+/**
+ * contains list of values, and the utility for this combi of values. The values
+ * make only sense with a corresponding list of issues, but that is managed in
+ * (see {@link PartsUtilities}.
+ * <p>
+ * immutable.
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+class PartUtil {
+	private final List<Value> values;
+
+	private final BigDecimal util;
+
+	@JsonCreator
+	public PartUtil(@JsonProperty("values") List<Value> values,
+			@JsonProperty("util") BigDecimal util) {
+		this.values = values;
+		this.util = util;
+	}
+
+	public List<Value> getValues() {
+		return values;
+	}
+
+	public BigDecimal getUtil() {
+		return util;
+	}
+}
Index: /profile/src/main/java/geniusweb/profile/utilityspace/ProductOfValue.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/ProductOfValue.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/ProductOfValue.java	(revision 9)
@@ -0,0 +1,75 @@
+package geniusweb.profile.utilityspace;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonValue;
+import com.fasterxml.jackson.databind.JsonDeserializer;
+import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
+
+import geniusweb.issuevalue.Value;
+
+/**
+ * A {@link Value} that is the product of some existing values
+ */
+@JsonDeserialize(using = JsonDeserializer.None.class)
+public class ProductOfValue implements Value {
+	private final List<Value> values = new ArrayList<Value>();
+
+	/**
+	 * @param values the values to make a product of
+	 */
+	@JsonCreator
+	public ProductOfValue(List<Value> newvals) {
+		values.addAll(newvals);
+	}
+
+	@JsonValue
+	public List<Value> getValues() {
+		return values;
+	}
+
+	@Override
+	public String toString() {
+		return values.toString();
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((values == null) ? 0 : values.hashCode());
+		return result;
+	}
+
+	/**
+	 * 
+	 * @param other a {@link ProductOfValue} with more issues to be merged into
+	 *              this.
+	 * @return new ProductOfValue that contains this and other values.
+	 */
+	public ProductOfValue merge(ProductOfValue other) {
+		List<Value> newvalues = new ArrayList<Value>(values);
+		newvalues.addAll(other.getValues());
+		return new ProductOfValue(newvalues);
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		ProductOfValue other = (ProductOfValue) obj;
+		if (values == null) {
+			if (other.values != null)
+				return false;
+		} else if (!values.equals(other.values))
+			return false;
+		return true;
+	}
+
+}
